#include "Menu.h"

Menu::Menu(sf::Font &font)
{
	this->font = &font;
	this->text = new sf::Text();
	this->text->setFont(*this->font);
	this->text->setCharacterSize(20);
	this->text->setColor(sf::Color::White);
	this->text->setStyle(sf::Text::Regular);
	this->activeIndex = 0;
	this->menuPointCounter = 0;
}

void Menu::addPoint(std::string name)
{
	menuPoints.push_back(MenuPoint(name));
	this->menuPointCounter++;
}

void Menu::setActive(int index)
{
	this->activeIndex = index;
}

int Menu::getActiveIndex()
{
	return this->activeIndex;
}

void Menu::setNextActive()
{
	this->activeIndex = (this->activeIndex + 1) % this->menuPointCounter;
}
void Menu::setPreviousActive()
{
	this->activeIndex = (this->activeIndex + this->menuPointCounter - 1) % this->menuPointCounter;
}

void Menu::drawMenu(sf::RenderWindow &window)
{
	int index = 0;

	for(std::vector<MenuPoint>::iterator it = menuPoints.begin(); it != menuPoints.end(); it++)
	{
		this->text->setString(it->menuName);
		this->text->setPosition(40, index * 30 +50);

		this->text->setColor(index == this->activeIndex ? sf::Color::Blue : sf::Color::Green);

		window.draw(*this->text);
		index++;
	}
}

bool Menu::selectMenuPoint(sf::Vector2i &mouse)
{
	int index  = 0;
	sf::FloatRect *fr;

	for(std::vector<MenuPoint>::iterator it = menuPoints.begin(); it != menuPoints.end(); it++)
	{
		this->text->setString(it->menuName);
		this->text->setPosition(40, index * 30 +50);

		fr = &this->text->getGlobalBounds();

		if(fr->contains(mouse.x, mouse.y))
		{
			this->activeIndex = index;
			return true;
		}

		index++;
	}

	return false;
}