#pragma once

#include <vector>
#include <SFML/Graphics.hpp>

struct field {
	int bombs_around;
	bool bomb;
	bool clicked;
	bool visible;
	sf::Sprite sp;
};

enum State 
{
	OK, BOMB, END
};

class Minesweeper
{
public:
	Minesweeper(int width, int height, int bombs, sf::Texture &bomb, sf::Texture &bomb_explosion, sf::Texture &open, sf::Texture &closed, sf::Font &font);
	~Minesweeper(void);
	void printfield(sf::RenderWindow &window, int field_size, int x_start, int y_start);
	void openBombs();
	void generateGame(int bombs);
	State activateField(int x, int y);

private: 
	void increaseCounter(int pos);
	field *fields;
	int left_fields;
	int width;
	int height;
	int size;
	sf::Text text;
	sf::Texture bomb;
	sf::Texture bomb_explosion;
	sf::Texture open;
	sf::Texture closed;
};